--v.3
--REM: DEPENDS ON OPTIONS!

include( "PopupDialog" );

--REM: DEPENDS ON TutorialUIRoot!
local check_MOD = true;
local checkPending = check_MOD;
local modID = "d78aa972-a1e5-4980-a637-684bcdb033c3";
local block_INIT = false;

local resHorses = GameInfo.Resources["RESOURCE_HORSES"].Index; --NOTE: imported resources does NOT count.
local resIron = GameInfo.Resources["RESOURCE_IRON"].Index;
local resUranium = GameInfo.Resources["RESOURCE_URANIUM"].Index; --TECH_COMPOSITES 
local resOil = GameInfo.Resources["RESOURCE_OIL"].Index; --TECH_COMBUSTION 

local techMilitaryScience = GameInfo.Technologies["TECH_MILITARY_SCIENCE"].Index; --UNIT_CAVALRY
local techHorseback = GameInfo.Technologies["TECH_HORSEBACK_RIDING"].Index; --UNIT_HORSEMAN
local techStirrups = GameInfo.Technologies["TECH_STIRRUPS"].Index; --UNIT_KNIGHT
local techIron = GameInfo.Technologies["TECH_IRON_WORKING"].Index; --UNIT_SWORDSMAN
local techComposites = GameInfo.Technologies["TECH_COMPOSITES"].Index; --UNIT_MODERN_ARMOR
local techCombustion = GameInfo.Technologies["TECH_COMBUSTION"].Index; --UNIT_TANK
local techSatellites = GameInfo.Technologies["TECH_SATELLITES"].Index; --UNIT_MECHANIZED_INFANTRY
local techAdvBallistics = GameInfo.Technologies["TECH_ADVANCED_BALLISTICS"].Index; --UNIT_MACHINE_GUN
local techReplaceableParts = GameInfo.Technologies["TECH_REPLACEABLE_PARTS"].Index; --UNIT_INFANTRY
local techBallistics = GameInfo.Technologies["TECH_BALLISTICS"].Index; --UNIT_FIELD_CANNON
local techMachinery = GameInfo.Technologies["TECH_MACHINERY"].Index; --UNIT_CROSSBOWMAN
local techArchery = GameInfo.Technologies["TECH_ARCHERY"].Index; --UNIT_ARCHER

local religionBonus = 0;
local humanReligion = -1;

local aiPlayers = 5;
local humanFriends = 0;
local hWars = 0;

local gameTurn:number = 0;

local siegeTable:table = {};

function OnCitySiegeStatusChanged(a1, a2, a3)

	local pCity = CityManager.GetCity(a1, a2);
	local pPlayer = Players[a1];
	if pCity ~= nil then
		local cName:string = pCity:GetName();
		siegeTable = {cName = a3};
		--print(cName.." siege: "..tostring(siegeTable.cName));
		--cTable[cName].siege = a3;
		if pPlayer:GetDiplomacy():IsAtWarWithHumans() and a3 then
			local cPop = pCity:GetPopulation();
			if (cPop >= 2) then
				local unit = EraUnit(pPlayer);
				--print("OnCitySiegeStatusChanged: "..unit);
				UnitManager.InitUnit(a1, unit, pCity:GetX(), pCity:GetY());
				pCity:ChangePopulation(1);
			end --cPop
		end --war with humans
		----print("OnCitySiegeStatusChanged: "..tostring(a1).." "..tostring(a2).." "..tostring(a3).." "..tostring(cName));
	end	--pCity ~= nil
end



function WarWithHuman()

	--print(" ");
if hWars >0 then
	local tMajors = PlayerManager.GetAliveMajors();
	local hWar = 0;
	local pWarTable = {};

	for i, aiPlayer in ipairs(tMajors) do
		if aiPlayer:GetDiplomacy():IsAtWarWithHumans() and not aiPlayer:IsBarbarian() then
			hWar = hWar + 1;
			local cLimit = aiPlayer:GetCities():GetCount();
			local aiPlayerID = aiPlayer:GetID();
			local era1:number = aiPlayer:GetEra() +1;
			local scienceWar = math.ceil(aiPlayer:GetTechs():GetScienceYield()*0.2);
			local cultureWar = math.ceil(aiPlayer:GetCulture():GetCultureYield()*0.2);
			local religionWar = math.ceil(aiPlayer:GetReligion():GetFaithYield()*0.2);
			--local religionWar = math.ceil(cLimit*(era1^2)*0.5);
			--local cultureWar = math.ceil(cLimit*(era1^2)*0.5);
			--local scienceWar = math.ceil(cLimit*(era1^2)*0.5);
			local goldWar = math.ceil(cLimit*era1);
			table.insert(pWarTable, aiPlayerID);
			
			aiPlayer:GetReligion():ChangeFaithBalance(religionWar);
			aiPlayer:GetCulture():ChangeCurrentCulturalProgress(cultureWar);
			--aiPlayer:GetTreasury():ChangeGoldBalance(goldWar);
			aiPlayer:GetTechs():ChangeCurrentResearchProgress(scienceWar);
			--print("WarWithHuman:"..tostring(aiPlayerID).." era1:"..tostring(era1).." cLimit:"..tostring(cLimit).." scienceWar:"..tostring(scienceWar).." cultureWar:"..tostring(cultureWar).." religionWar:"..tostring(religionWar));
		end	--at war
	end --loop1
			
	if hWar > 0 then
		for i2, loopPlayer in ipairs(tMajors) do
			local loopPlayerDiplo = loopPlayer:GetDiplomacy(); 
			if not loopPlayerDiplo:IsAtWarWithHumans() and not loopPlayer:IsHuman() and not loopPlayer:IsBarbarian() then
				for i, pAtWar in ipairs(pWarTable) do
					if loopPlayerDiplo:HasMet(humanID) or loopPlayerDiplo:HasMet(pAtWar) then
					local cLimit2 = loopPlayer:GetCities():GetCount();
					local loopPlayerID = loopPlayer:GetID();
					local era2:number = loopPlayer:GetEra() +1;
					local scienceWar2 = math.ceil(loopPlayer:GetTechs():GetScienceYield()*0.1);
					local cultureWar2 = math.ceil(loopPlayer:GetCulture():GetCultureYield()*0.1);
					local religionWar2 = math.ceil(loopPlayer:GetReligion():GetFaithYield()*0.1);
					local goldWar2 = math.ceil(cLimit2*era2*0.5);
					
					loopPlayer:GetReligion():ChangeFaithBalance(religionWar2);
					loopPlayer:GetCulture():ChangeCurrentCulturalProgress(cultureWar2);
					--loopPlayer:GetTreasury():ChangeGoldBalance(goldWar2);
					loopPlayer:GetTechs():ChangeCurrentResearchProgress(scienceWar2);
					--print("WarTime:"..tostring(loopPlayerID).." era2:"..tostring(era2).." cLimit2:"..tostring(cLimit2).." science:"..tostring(scienceWar2).." culture:"..tostring(cultureWar2).." faith:"..tostring(religionWar2));
				break
					end
				end --loop pWarTable
			end --not human
		end --loop all other players
	else --war >0
		hWars = 0;
		LuaEvents.Custom_HumanWars(hWars);
	end
end --hWars>0
end


function EraUnit(pPlayer:table) 

	local unit:string = nil;
	local isWarmonger = false;
	
	local playerID = pPlayer:GetID();
	local isTarget = false; 
	
	if not pPlayer:GetDiplomacy():IsAtWarWith(humanID) then
		local aliveIDs	:table = PlayerManager.GetAliveIDs();
		for i, alive in ipairs(aliveIDs) do
			if (alive <62 and pPlayer:GetDiplomacy():IsAtWarWith(alive)) then --alive ~= 62 otherwise => exploit!
				isWarmonger = true;
				--print("Player is at War with non-human: "..tostring(alive));
		break
			end --IsAtWarWith
		end --loop1 aliveIDs
	end
	
	if not isWarmonger then
	
		if pPlayer:GetResources():HasResource(resUranium) and pPlayer:GetTechs():HasTech(techComposites)  then
			unit = "UNIT_MODERN_ARMOR";
			return unit;
		end
		
		if pPlayer:GetTechs():HasTech(techSatellites) then
			unit = "UNIT_MECHANIZED_INFANTRY";
			return unit;
		end
		
		if pPlayer:GetTechs():HasTech(techAdvBallistics) then
			unit = "UNIT_MACHINE_GUN";
			return unit;
		end
	
		if pPlayer:GetResources():HasResource(resOil) and pPlayer:GetTechs():HasTech(techCombustion)  then
			unit = "UNIT_TANK";
			return unit;
		end
		
		if pPlayer:GetTechs():HasTech(techReplaceableParts) then
			unit = "UNIT_INFANTRY";
			return unit;
		end
		
		if pPlayer:GetResources():HasResource(resHorses) and pPlayer:GetTechs():HasTech(techMilitaryScience) then
			unit = "UNIT_CAVALRY";
			return unit;
		end
		
		if pPlayer:GetTechs():HasTech(techBallistics) then
			unit = "UNIT_FIELD_CANNON";
			return unit;
		end
			
		if pPlayer:GetResources():HasResource(resIron) and pPlayer:GetTechs():HasTech(techStirrups) then
			unit = "UNIT_KNIGHT";
			return unit;
		end
		
		if pPlayer:GetTechs():HasTech(techMachinery) then
			unit = "UNIT_CROSSBOWMAN";
			return unit;
		end
			
		if pPlayer:GetResources():HasResource(resHorses) and pPlayer:GetTechs():HasTech(techHorseback) then
			unit = "UNIT_HORSEMAN";
			return unit;
		end
		
		if pPlayer:GetResources():HasResource(resIron) and pPlayer:GetTechs():HasTech(techIron) then
			unit = "UNIT_SWORDSMAN";
			return unit;
		end
	
		if pPlayer:GetTechs():HasTech(techArchery) then
			unit = "UNIT_ARCHER";
			return unit;
		else
			unit = "UNIT_WARRIOR";
		end
	end --not isWarmonger
	return unit;
end

function CountMilitaryUnits(pID) --problem is script context does not allow for direct military strength valuation

	local unitCount = 0;
	local playerUnits = Players[pID]:GetUnits();
	for i, unit in playerUnits:Members() do
		local unitType = unit:GetType();
		if unitType > 19 then --this is risky sss, how to improve???
			unitCount = unitCount +1;	
		end
	end
	return unitCount;
end

function AdjustBonuses()

	local tMajors = PlayerManager.GetAliveMajors();
	local hMilitary = CountMilitaryUnits(humanID);
	local hScience = Players[humanID]:GetTechs():GetScienceYield();
	local hCulture = Players[humanID]:GetCulture():GetCultureYield();
	--local hReligion = Players[humanID]:GetReligion():GetFaithYield();
	
	local hTech = Players[humanID]:GetTechs():GetResearchingTech();
	local hCivic = Players[humanID]:GetCulture():GetProgressingCivic();
	local hFriends = 0; --temp during loop
	local adjustFriends = (1/aiPlayers)*humanFriends;
	
	for i, aiPlayer in ipairs(tMajors) do
		if not aiPlayer:IsHuman() and not aiPlayer:IsBarbarian() then
			local aiPlayerID = aiPlayer:GetID();
			local pCitiesCount = aiPlayer:GetCities():GetCount();
			--print("--------------------------------------------------");
			--print("PLAYER: "..aiPlayerID.." "..PlayerConfigurations[aiPlayerID]:GetLeaderTypeName());
			local balance = aiPlayer:GetTreasury():GetGoldBalance();
			local era = aiPlayer:GetEra() +1;
			local goldRequirement = era*10;
			local finalBalance = balance - goldRequirement;
			
			local aiPlayerDiplomaticAI = aiPlayer:GetAi_Diplomacy();
			local relationshipState = aiPlayerDiplomaticAI:GetDiplomaticState(humanID);
			local fFactor = 1;
			local visibilityState = aiPlayer:GetDiplomacy():GetVisibilityOn(humanID);
			local metState = aiPlayer:GetDiplomacy():HasMet(humanID);
			local pMilitary = CountMilitaryUnits(aiPlayerID);
			local pScience = aiPlayer:GetTechs():GetScienceYield();
			local pCulture = aiPlayer:GetCulture():GetCultureYield();
			local pReligion = aiPlayer:GetReligion():GetFaithYield();
			local mRatio = (hMilitary/pMilitary);
			
			local pTech = aiPlayer:GetTechs():GetResearchingTech();
			local pCivic = aiPlayer:GetCulture():GetProgressingCivic();
			
			local unit = nil;
			if (relationshipState ~= nil and aiPlayer:GetDiplomacy():HasMet(humanID)) then
				--print(relationshipState.." "..Round(finalBalance, 2).." "..Round(mRatio, 2));
				if (relationshipState == "DIPLO_STATE_ALLIED") then
					hFriends = hFriends +1;
					fFactor = 0;
					if hCivic > pCivic then
						cBonus = math.ceil(hCulture*0.25*visibilityState);
						aiPlayer:GetCulture():ChangeCurrentCulturalProgress(cBonus);
						--print("Culture bonus: "..cBonus);
					end --hCivic > pCivic
					if (finalBalance > 0) then
						if hTech > pTech then
							sBonus = math.ceil(hScience*0.25*visibilityState);
							aiPlayer:GetTechs():ChangeCurrentResearchProgress(sBonus);
							--print("Science bonus: "..sBonus);
						end --hTech > pTech
						if mRatio > 2 + adjustFriends then 
							unit = EraUnit(aiPlayer);
						end
					end --balance
				end
				if (relationshipState == "DIPLO_STATE_DECLARED_FRIEND") then
					hFriends = hFriends +1;
					fFactor = 0.25;
					if hCivic > pCivic then
						cBonus = math.ceil(hCulture*0.25*visibilityState);
						aiPlayer:GetCulture():ChangeCurrentCulturalProgress(cBonus);
						--print("Culture bonus: "..cBonus);
					end --hCivic > pCivic
					if (finalBalance > 0) then
						if hTech > pTech then
							sBonus = math.ceil(hScience*0.25*visibilityState);
							aiPlayer:GetTechs():ChangeCurrentResearchProgress(sBonus);
							--print("Science bonus: "..sBonus);
						end --hTech > pTech
						if mRatio > 1.6 + adjustFriends then 
							unit = EraUnit(aiPlayer);
						end
					end --balance
				end --relationshipState
				if (relationshipState == "DIPLO_STATE_FRIENDLY") then
					hFriends = hFriends +1;
					fFactor = 0.5;
					if hCivic > pCivic then
						cBonus = math.ceil(hCulture*0.25*visibilityState);
						aiPlayer:GetCulture():ChangeCurrentCulturalProgress(cBonus);
						--print("Culture bonus: "..cBonus);
					end --hCivic > pCivic
					if (finalBalance > 0) then
						if hTech > pTech then
							sBonus = math.ceil(hScience*0.25*visibilityState);
							aiPlayer:GetTechs():ChangeCurrentResearchProgress(sBonus);
							--print("Science bonus: "..sBonus);
						end --hTech > pTech
						if mRatio > 1.3 + adjustFriends then 
							unit = EraUnit(aiPlayer);
						end
					end --balance
				end
				-----------------------------------------------------------------------------------
				if (relationshipState == "DIPLO_STATE_NEUTRAL") then
					fFactor = 0.75;
					if metState and hCivic > pCivic then
						cBonus = math.ceil(hCulture*0.25*visibilityState);
						aiPlayer:GetCulture():ChangeCurrentCulturalProgress(cBonus);
						--print("Culture bonus: "..cBonus);
					end --hCivic > pCivic
					if (finalBalance > 0) then
						if metState and hTech > pTech then
							sBonus = math.ceil(hScience*0.25*visibilityState);
							aiPlayer:GetTechs():ChangeCurrentResearchProgress(sBonus);
							--print("Science bonus: "..sBonus);
						end --hTech > pTech
						if mRatio > 1 + adjustFriends then
							unit = EraUnit(aiPlayer);
						end
					end	
				end
				if (relationshipState == "DIPLO_STATE_UNFRIENDLY") then
					if (finalBalance > 0) then
						if mRatio > 0.8 + adjustFriends then
							unit = EraUnit(aiPlayer);
						end
					end	
				end
				if (relationshipState == "DIPLO_STATE_DENOUNCED") then
					if (finalBalance > 0) then
						if mRatio > 0.6 + adjustFriends then
							unit = EraUnit(aiPlayer);
						end
					end	
				end
				if (relationshipState == "DIPLO_STATE_WAR") then
					if (finalBalance > 0) then
						if mRatio > 0.6 + adjustFriends then
							unit = EraUnit(aiPlayer);
						end
					end	
				end
				
				--COMBAT UNITS:
				if unit ~= nil  then
					local unitIndex = GameInfo.Units[unit].Index;
					if unitIndex ~= nil then
						local pPlayerCities:table = aiPlayer:GetCities();
						for i, pLoopCity in pPlayerCities:Members() do
						local cName:string = pLoopCity:GetName();
							--local underSiege = cTable[cName].siege;
							local underSiege = siegeTable.cName;
							--print("SIEGE: "..cName.." "..tostring(underSiege));
							if not underSiege then
								local cX = pLoopCity:GetX();
								local cY = pLoopCity:GetY();
								UnitManager.InitUnit(aiPlayerID, unit, cX, cY);
								--print("GRANTING BONUS UNIT: "..aiPlayerID.." "..unit.." "..cName);
						break
							end --siege
						end --pLoopCity
					end --unitIndex
				end --unit
			end --relationshipState not nil
			
			--GLOBALIZATION:
			local adjustFriendsGlobal = 1; --1-adjustFriends;
			local majorsAdjust = MajorsAd();
			for i2, aiPlayer2 in ipairs(tMajors) do
				local aiPlayer2ID = aiPlayer2:GetID();
				local relationshipState2 = aiPlayerDiplomaticAI:GetDiplomaticState(aiPlayer2ID);
				if (not aiPlayer2:IsHuman() and aiPlayer2ID ~= aiPlayerID and relationshipState2 ~= nil and aiPlayer:GetDiplomacy():HasMet(aiPlayer2ID)) then
					if relationshipState2 == "DIPLO_STATE_ALLIED" or relationshipState2 == "DIPLO_STATE_DECLARED_FRIEND" or relationshipState2 == "DIPLO_STATE_FRIENDLY" then
						local pCultureGlobal = math.ceil(pCulture *majorsAdjust *fFactor);
						local pScienceGlobal = math.ceil(pScience *majorsAdjust *fFactor);
						local pReligionGlobal = math.ceil(pReligion *majorsAdjust *fFactor);
						aiPlayer2:GetCulture():ChangeCurrentCulturalProgress(pCultureGlobal);
						aiPlayer2:GetTechs():ChangeCurrentResearchProgress(pScienceGlobal);
						aiPlayer2:GetReligion():ChangeFaithBalance(pReligionGlobal);
						--print(" ");
						--print(tostring(aiPlayerID).." -> "..aiPlayer2ID.." "..relationshipState2);
						--print("Science shared: "..pScience.." "..majorsAdjust.." 1 "..fFactor.." "..pScienceGlobal);
						--print("Culture shared: "..pCulture.." "..majorsAdjust.." 1 "..fFactor.." "..pCultureGlobal);
						--print("Faith shared: "..pReligion.." "..majorsAdjust.." 1 "..fFactor.." "..pReligionGlobal);
					elseif relationshipState2 == "DIPLO_STATE_NEUTRAL" then
						local pCultureGlobal = math.ceil(pCulture *0.5 *fFactor *majorsAdjust);
						local pScienceGlobal = math.ceil(pScience *0.5 *fFactor *majorsAdjust);
						local pReligionGlobal = math.ceil(pReligion *0.5 *fFactor *majorsAdjust);
						aiPlayer2:GetCulture():ChangeCurrentCulturalProgress(pCultureGlobal);
						aiPlayer2:GetTechs():ChangeCurrentResearchProgress(pScienceGlobal);
						aiPlayer2:GetReligion():ChangeFaithBalance(pReligionGlobal);
						--print(" ");
						--print(tostring(aiPlayerID).." -> "..aiPlayer2ID.." "..relationshipState2);
						--print("Science shared: "..pScience.." "..majorsAdjust.." 0.5 "..fFactor.." "..pScienceGlobal);
						--print("Culture shared: "..pCulture.." "..majorsAdjust.." 0.5 "..fFactor.." "..pCultureGlobal);
						--print("Faith shared: "..pReligion.." "..majorsAdjust.." 0.5 "..fFactor.." "..pReligionGlobal);
					else
						--print(" ");
						--print(tostring(aiPlayerID).." -> "..aiPlayer2ID.." "..relationshipState2);
					end --relationshipState2
				end --not aiPlayer2:IsHuman()
			end --aiPlayer2
		end --loop1 if not human
	end --loop1 tMajors
	
	humanFriends = hFriends;
	LuaEvents.Custom_Friends(humanFriends);
	
end

function MajorsAd()
	local majorsCount = PlayerManager.GetAliveMajorsCount();
	local majors = 1;
	if majorsCount>2 then 
		majors = 1/(majorsCount-2);
	end 
	return majors;
end

function Round(num, numDecimalPlaces)
    local mult = 10^(numDecimalPlaces or 0)
    if num >= 0 then return math.floor(num * mult + 0.5) / mult
    else return math.ceil(num * mult - 0.5) / mult end
end

function OnUnitChargesChanged(player, unitId) --xxx

	if(gameTurn ~= 0 and player == humanID) then
		local unit = UnitManager.GetUnit(player, unitId);
		if (unit:GetReligion():GetReligiousStrength()) > 0 then
			religionBonus = religionBonus +1;
			LuaEvents.Custom_ExtraReligion(religionBonus);
		end
	end
end

function ApplyReligionBonus() --xxx

	--print("ApplyReligionBonus(religionBonus): "..religionBonus);

	if (religionBonus >= 3) then
		religionBonus = religionBonus -3;
		--print("ApplyReligionBonus function");
		local tAllPlayers = PlayerManager.GetAlive();
		for i, loopPlayer in ipairs(tAllPlayers) do
			if not loopPlayer:IsHuman() and not loopPlayer:IsBarbarian() then
				local faithBalance = loopPlayer:GetReligion():GetFaithBalance();
				local loopPlayerID = loopPlayer:GetID();
				local minFaith = 200;
				--print(loopPlayerID.." - "..faithBalance);
				if (faithBalance >= minFaith) then
					local goToCities = false;
					local creator = -1;
					if loopPlayer:IsMajor() then 
						creator = loopPlayer:GetReligion():GetReligionTypeCreated();
						--print("creator: "..creator);
						local aiPlayerDiplomaticAI = loopPlayer:GetAi_Diplomacy();
						local relationsHuman = aiPlayerDiplomaticAI:GetDiplomaticState(humanID);
						if creator ~= -1 or (relationsHuman == "DIPLO_STATE_ALLIED" or relationsHuman == "DIPLO_STATE_DECLARED_FRIEND" or relationsHuman == "DIPLO_STATE_FRIENDLY" or relationsHuman == "DIPLO_STATE_NEUTRAL") then 
							goToCities = true;
							--print("goToCities creator")
						end --relationsHuman
					else --now is CityState
						local suzerain = loopPlayer:GetInfluence():GetSuzerain();
						--print("suzerain: "..suzerain);
						if (suzerain == -1 or suzerain == humanID) then
							goToCities = true;
							--print("goToCities suzerain")
						else
							local relHumSuz = Players[suzerain]:GetAi_Diplomacy():GetDiplomaticState(humanID);
							--print("relHumSuz: "..relHumSuz);
							if relHumSuz == "DIPLO_STATE_ALLIED" or relHumSuz == "DIPLO_STATE_DECLARED_FRIEND" or relHumSuz == "DIPLO_STATE_FRIENDLY" or relHumSuz == "DIPLO_STATE_NEUTRAL" then
								goToCities = true;
								--print("goToCities relHumSuz")
							end
						end --suzerain == -1
					end --IsMajor
					
					if goToCities then
						local tCities = loopPlayer:GetCities();
						--print("Starting looping cities");
						for i2, pLoopCity in tCities:Members() do
							local pLoopName = pLoopCity:GetName();
							local religionType = pLoopCity:GetReligion():GetMajorityReligion();
							--print(pLoopName.." religion: "..tostring(religionType));
							if religionType == creator or religionType == humanReligion then
								local unitOwner;
								if religionType == creator then unitOwner = loopPlayerID; else unitOwner = humanID; end
								local hasShrine = pLoopCity:GetBuildings():HasBuilding(GameInfo.Buildings["BUILDING_SHRINE"].Index) and not pLoopCity:GetBuildings():IsPillaged(GameInfo.Buildings["BUILDING_SHRINE"].Index); --xxx
								local hasTemple = (pLoopCity:GetBuildings():HasBuilding(GameInfo.Buildings["BUILDING_TEMPLE"].Index) and not pLoopCity:GetBuildings():IsPillaged(GameInfo.Buildings["BUILDING_TEMPLE"].Index)) or (pLoopCity:GetBuildings():HasBuilding(GameInfo.Buildings["BUILDING_STAVE_CHURCH"].Index) and not pLoopCity:GetBuildings():IsPillaged(GameInfo.Buildings["BUILDING_STAVE_CHURCH"].Index)) or (pLoopCity:GetBuildings():HasBuilding(GameInfo.Buildings["BUILDING_PRASAT"].Index) and not pLoopCity:GetBuildings():IsPillaged(GameInfo.Buildings["BUILDING_PRASAT"].Index)); --xxx
								local hasInquisition = loopPlayer:GetReligion():HasLaunchedInquisition();
								local cX = pLoopCity:GetX();
								local cY = pLoopCity:GetY();
								--print(pLoopName.." "..tostring(hasTemple).." "..tostring(hasShrine).." "..tostring(hasInquisition));
								if hasTemple and faithBalance >= minFaith then
									--print("hasTemple: "..pLoopName);
									UnitManager.InitUnitValidAdjacentHex(unitOwner, "UNIT_APOSTLE", cX, cY, 1);
									faithBalance = faithBalance - minFaith;
									if religionType == humanReligion then 
										religionBonus = religionBonus -4; 
										--print("religionBonus: "..-4);
									end
									--print("GRANTED RELIGIOUS UNIT: "..pLoopName.." UNIT_APOSTLE "..faithBalance);
								end --hasTemple
								if hasShrine and faithBalance >= minFaith *0.25 then
									--print("hasShrine: "..pLoopName);
									UnitManager.InitUnitValidAdjacentHex(unitOwner, "UNIT_MISSIONARY", cX, cY, 1);
									faithBalance = faithBalance - minFaith *0.25;
									if religionType == humanReligion then
										religionBonus = religionBonus -4; 
										--print("religionBonus: "..-4); 
									end
									--print("GRANTED RELIGIOUS UNIT: "..pLoopName.." UNIT_MISSIONARY "..faithBalance);
								end --hasShrine
								if religionType == creator and hasTemple and hasInquisition and faithBalance >= minFaith *0.25 then
									--print("hasInquisition: "..pLoopName);
									UnitManager.InitUnitValidAdjacentHex(unitOwner, "UNIT_INQUISITOR", cX, cY, 1);
									faithBalance = faithBalance - minFaith *0.25;
									--print("GRANTED RELIGIOUS UNIT: "..pLoopName.." UNIT_INQUISITOR "..faithBalance);
								end --hasInquisition
							end --religionType
						end --pLoopCity
					end --goToCities
				end --faithBalance
			end --not IsHuman 
		end --loopPlayer
		
		SetUnitsReligion();
		LuaEvents.Custom_ExtraReligion(religionBonus);
	end	--religionBonus
end

function SetUnitsReligion()

	local tAllPlayers = PlayerManager.GetAlive();
	for i, loopPlayer in ipairs(tAllPlayers) do
		local creator = loopPlayer:GetReligion():GetReligionTypeCreated();
		if creator ~= -1 then
			local loopPlayerID = loopPlayer:GetID();
			local tUnits = loopPlayer:GetUnits();
			for i, unit in tUnits:Members() do
				if (unit:GetReligion():GetReligiousStrength() > 0 and  unit:GetReligion():GetReligionType() == -1) then
					local unitID = unit:GetID();
					local unitX = unit:GetX();
					local unitY = unit:GetY();
					unit:GetReligion():SetReligionType(creator);
					--print("SetUnitsReligion");
				end --GetReligiousStrength
			end --loop unit
		end --creator
	end --loopPlayer
end

function OnDiplomacyDeclareWar( firstPlayerID:number, secondPlayerID:number )
		--print("OnDiplomacyDeclareWar: "..tostring(firstPlayerID).." "..tostring(secondPlayerID));
	local localPlayer = Game.GetLocalPlayer();
	if firstPlayerID == localPlayer then --or secondPlayerID == localPlayer then
		----print("OnDiplomacyDeclareWar: "..tostring(firstPlayerID).." "..tostring(secondPlayerID));
		hWars = hWars +1;
		LuaEvents.Custom_HumanWars(hWars);
	end
end

function OnDiplomacyMakePeace( firstPlayerID:number, secondPlayerID:number )
		--print("OnDiplomacyMakePeace: "..tostring(firstPlayerID).." "..tostring(secondPlayerID));
	local localPlayer = Game.GetLocalPlayer();
	if hWars > 0 and (firstPlayerID == localPlayer or secondPlayerID == localPlayer) then
		----print("OnDiplomacyMakePeace: "..tostring(firstPlayerID).." "..tostring(secondPlayerID));
		hWars = hWars -1;
		LuaEvents.Custom_HumanWars(hWars);
	end
end

function OnTurnBegin(turn)
	gameTurn = turn;
	--print("OnTurnBegin: "..tostring(turn));
	if checkPending == true and check_MOD == true then
		if GameConfiguration.GetValue("block_INIT") ~= nil then block_INIT = GameConfiguration.GetValue("block_INIT") end;
		if block_INIT == false then
			checkPending = false;
			Initialize();
		else
			print("MODS CONFLICT ERROR: INIT BLOCKED!");
			print("Conflicting MOD: "..modID);
			local pPopupDialog	:table = PopupDialogInGame:new("AdaptiveDifficultyConflict"); 
			pPopupDialog:AddTitle("Warning!" );	
			pPopupDialog:AddText("Adaptive Difficulty mod is included in More Strategy. [NEWLINE]Disable one of them and start a new game!");
			pPopupDialog:AddDefaultButton("OK");
			pPopupDialog:Open();
		end
	end
end

function OnTurnEnd(turn)
	gameTurn = turn;
	--print("--------------------------------------------------");
	--print("TURN END: "..gameTurn);
	AdjustBonuses();
	WarWithHuman();
	ApplyReligionBonus();
	--print("--------------------------------------------------");
end

Events.TurnBegin.Add( OnTurnBegin );
	if GameConfiguration.GetValue("humanFriends") ~= nil then humanFriends = GameConfiguration.GetValue("humanFriends") end;
	if GameConfiguration.GetValue("religionBonus") ~= nil then religionBonus = GameConfiguration.GetValue("religionBonus") end;
	if GameConfiguration.GetValue("hWars") ~= nil then hWars = GameConfiguration.GetValue("hWars") end;
	aiPlayers = PlayerManager.GetWasEverAliveMajorsCount() -1;
	humanID = Game.GetLocalPlayer();
	humanReligion = Players[humanID]:GetReligion():GetReligionTypeCreated();

function Initialize()
	print("--------------------------------------------------");

	Events.TurnEnd.Add( OnTurnEnd );
	Events.UnitChargesChanged.Add( OnUnitChargesChanged );
	Events.CitySiegeStatusChanged.Add( OnCitySiegeStatusChanged );
	Events.DiplomacyDeclareWar.Add(				OnDiplomacyDeclareWar );
	Events.DiplomacyMakePeace.Add(				OnDiplomacyMakePeace );
	
	print("ADAPTIVE DIFFICULTY STARTED: v.3");
	print("aiPlayers: "..tostring(aiPlayers));
	print("humanFriends: "..tostring(humanFriends));
	print("hWars: "..tostring(hWars));
	print("humanReligion: "..tostring(humanReligion));
	print("religionBonus: "..tostring(religionBonus));
	print("--------------------------------------------------");
	
end

if check_MOD == false then
	Initialize();
end